$    ver = 'f$verify(0)
$!-
$!   Full comments are at the end of the file
$!-
$    set noon
$    __       		= "WRITE SYS$OUTPUT"
$    true     		= 1 .and. 1
$    false    		= 1 .and. 0
$    exit_sts		= 1
$    delete_search_file = true
$
$!-  Files and directories
$    procedure	   = f$element(0, ";", f$environment("PROCEDURE"))
$    location	   = f$element(0, "]", procedure) + "]"
$    filename      = f$parse(procedure,,,"NAME")
$    search_f	   = location + filename + ".SEARCH"
$
$!-  Modify this variable if you want to search for other strings
$    strings       = """from remote IP""," + -
		     """230-Guest User""," + -
		     """550 You are not permitted""" 
$
$!-  Exit cleanly...
$    on control_y then goto finish
$
$!-  Get SYS$LOGIN for the ANONYMOUS account
$    open/read/share sysuaf sys$system:sysuaf.dat
$    read/key="ANONYMOUS                       " sysuaf sysuaf_line
$    anonymous_loc = f$edit(f$extract(117, 31, sysuaf_line), "TRIM") + -
		     f$edit(f$extract(149, 63, sysuaf_line), "TRIM") 
$    close sysuaf
$
$    search 'anonymous_loc'FTP_SERVER.*;* 'strings/out='search_f 'p1
$    exit_sts = $status
$    if .not. exit_sts then goto finish
$
$!-  Read data file
$    open/read/error=finish search_f 'search_f
$
$ read_loop:
$    read/end=read_loop_end search_f line
$    if line .nes. "" then goto 010$
$    goto read_loop
$
$ 010$:
$    char1 = f$extract(0, 1, line)
$    if char1 .eqs. "*" then goto 020$
$    goto read_loop
$
$ 020$:							!-
$    record_output = false				! New searched file...
$    read/end=read_error search_f line			!-
$    log_f = line
$    read/end=read_error search_f line
$    read/end=read_error search_f line
$    line = f$edit(line, "TRIM,COMPRESS")
$    from_host = f$element(5, " ", line) - ")" - "("
$    from_host = f$edit(from_host, "UPCASE")
$    from_ip   = f$element(4, " ", line)
$    if from_host .eqs. " " then from_host = from_ip
$    read/end=read_error search_f line
$    guest_name = f$element(3, " ", line)
$    read/end=read_loop_end search_f line
$
$!-  Output the line
$    __ " o ", from_host, " (", from_ip, ")"
$    __ "   User """, guest_name, """"
$
$    if line .eqs. "" then goto 030$
$    __ "   Possible breakin attempt in ", log_f	!-
$    record_output = true				! Record has been 
$							! displayed.
$							! Necessary to handle
$							! EOF conditions
$							! properly.
$ 030$:							!-
$    goto read_loop
$
$ read_loop_end:
$    if record_output then goto finish			!-
$    __ " o ", from_host, " (", from_ip, ")"		! Don't redisplay
$    __ "   User """, guest_name, """"			! records.
$							!-
$ 040$:
$    goto finish
$
$ read_error:
$    type sys$input
   The format of the search file was not what this procedure was expecting.
   Possible causes include:

      o VMS has been upgraded and SEARCH now writes the information in a
	different format.
      o A VMS upgrade has changed the location of the device and directory
	fields of SYSUAF records.
      o Multinet has been upgraded and the format of the FTP_SERVER.LOG
	files has changed

   The temporary file that receives the output from the SEARCH command
   will not be deleted as it usually is so that it can be examined.  The
$    __ "   file name is ", search_f, "."
$    delete_search_file = false
$    goto finish
$
$ finish:
$    if f$trnlnm("SEARCH_F") .nes. "" then close search_f
$    if f$trnlnm("SYSUAF")   .nes. "" then close sysuaf
$    if delete_search_file then - 
	if f$search(search_f) .nes. "" then -
	   delete/nolog/noconf 'search_f;*
$    ver = f$verify(ver)
$    exit 'exit_sts
$
$!-
$!   This procedure is designed to scan the FTP_SERVER logs that Multinet
$!   leaves in the anonymous FTP SYS$LOGIN directory.  It uses SEARCH to
$!   search for the identifying strings for the IP address, domainname,
$!   username (ident string), and "550 You are not permitted".  If the
$!   550 line is found then the full file spec of the log file is 
$!   reported so that the system manager can go and look to see what's
$!   going on.
$!
$!   You can pass it a parameter P1 that is used as a qualifier to the
$!   search command.  It was added so that only log files since a certain
$!   date can be selected.  The default behavior is to search ALL the
$!   files which match FTP_SERVER.*;* in the Anonymous FTP login directory.
$!
$!   The ANONYMOUS username record in SYS$SYSTEM:SYSUAF.DAT is read to
$!   obtain the login directory for the ANONYMOUS account.  If you're SYSUAF
$!   file isn't in SYS$SYSTEM you'll have to modify this procedure.  You'll
$!   also have to modify it if DEC changes the location of the device and
$!   directory information in SYSUAF records.
$!
$!   Procedure:   SCAN-ANONYMOUS.COM
$!   Programmer:  Brian McKeever, MCKEEVER@CSTP.UMKC.EDU
$!   Created:     1992-02-21
$!
$!   Modifications
$!	1992-02-21, Brian McKeever
$!		    New
$!-
